require 'pbm/all_commands'

module PBM
  class Interpreter
    class << self
      def load
        self.new.tap do |interpreter|
          interpreter.commands = AllCommands.load(interpreter)
        end
      end
    end

    attr_writer :running
    attr_accessor :commands

    def initialize
      @running = true
    end

    def exec command
      command = command.to_sym
      raise "#{command}: invalid command." unless @commands.has_key?(command)
      @commands[command].run
    end

    def running?
      !!@running
    end
  end
end
